# Curvey
Pythonic geometric processing of discrete planar closed curves

## Installation
```shell
pip install curvey
```

## Documentation
Tutorials and API documentation hosted [here](https://darikg.github.io/curvey/)

## Highlights

### Quick visualizations

<img src="https://raw.githubusercontent.com/darikg/curvey/main/static/curve_plot.png" alt="curve plotting" width="400"/>

Everything's numpy-, scipy-, and matplotlib-based.

### Curvature flows

<img src="https://raw.githubusercontent.com/darikg/curvey/main/static/willmore_flow.png" alt="willmore flow" width="400"/>

Implementations of curve-shortening flow, [singularity free mean curvature flow](
https://arxiv.org/abs/1203.6819), and [Willmore flow](
https://www.cs.cmu.edu/~kmcrane/Projects/ConformalWillmoreFlow/paper.pdf).

### Shape blending

<img src="https://raw.githubusercontent.com/darikg/curvey/main/static/curv_interp.png" alt="curvature based shape interpolation" width="500"/>

Implementations of linear shape blending and [curvature flow shape blending](
https://www.sciencedirect.com/science/article/pii/S016783961730016X).


### Approximate medial axis

<img src="https://raw.githubusercontent.com/darikg/curvey/main/static/ama.png" alt="approximate medial axis" width="150"/>

Implementation of the [approximate medial axis](
https://citeseerx.ist.psu.edu/document?repid=rep1&type=pdf&doi=cfc187181ce85d983843c4a184651dbd2a07e7e5).
